# beso
Python code for a topology optimization using CalculiX FEM solver. `beso` stands for a method coined:

**B**i-directional  
**E**volutionary  
**S**tructural  
**O**ptimization 
 
 An in-depth description of beso and its capabilities are available on the [dedicated beso wiki](https://github.com/calculix/beso/wiki/Basic-description).

![fine mesh](https://github.com/fandaL/beso/raw/master/wiki_files/example_3/results-fine_mesh.png)
![initial smooth](https://github.com/fandaL/beso/raw/master/wiki_files/example_3/results-initial_smooth.png)
![](https://github.com/fandaL/beso/raw/master/wiki_files/example_2/resulting_mesh.png)
![](https://github.com/fandaL/beso/raw/master/wiki_files/example_2/resulting_mesh_FI.png)

## Prerequisites

* CalculiX >= v2.17
* numpy
* FreeCAD >= v0.18

## Installation


## Usage

Description with a simple example are in [wiki](https://github.com/fandaL/beso/wiki).

* [Example 1](https://github.com/calculix/beso/wiki/Example-1:-simply-supported-2D-beam) Simply supported 2D beam
* [Example 2](https://github.com/calculix/beso/wiki/Example-2:-engine-bracket) Engine bracket
* [Example 3](https://github.com/calculix/beso/wiki/Example-3:-airplane-bearing-bracket) Airplane bearing bracket
* [Example 4](https://github.com/calculix/beso/wiki/Example-4:-GUI-in-FreeCAD) GUI in FreeCAD

## Developer

[@fandaL](https;//github.com/fandaL)

## License

LGPLv3 ([LICENSE](LICENSE))